' Functional Dependency Application
' Written by David J. Stein, Esq., Kevin Hardy, and Craig White. See "License.html" for terms and conditions of use.
'
' AttributeAndFDSetDetails - written by David J. Stein, Esq.
' This module shows the details of an attribute set and a functional dependency set.

Public Class AttributeAndFDSetDetails
 Inherits System.Windows.Forms.Form

#Region "Variables and initialization code"

 Dim FDSet As New ArrayList
 Dim AttributeSet As New ArrayList

#Region " Windows Form Designer generated code "

 Public Sub New(ByRef AttributeSet As ArrayList, ByRef FDSet As ArrayList)
  MyBase.New()
  InitializeComponent()
  ' Intake of parameters that were passed into this constructor:
  Me.AttributeSet = AttributeSet
  Me.FDSet = FDSet
 End Sub

 'Form overrides dispose to clean up the component list.
 Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
  If disposing Then
   If Not (components Is Nothing) Then
    components.Dispose()
   End If
  End If
  MyBase.Dispose(disposing)
 End Sub

 'Required by the Windows Form Designer
 Private components As System.ComponentModel.IContainer

 'NOTE: The following procedure is required by the Windows Form Designer
 'It can be modified using the Windows Form Designer.  
 'Do not modify it using the code editor.
 Friend WithEvents lbAttributes As System.Windows.Forms.ListBox
 Friend WithEvents lbFDSet As System.Windows.Forms.ListBox
 Friend WithEvents btnOK As System.Windows.Forms.Button
 Friend WithEvents Label1 As System.Windows.Forms.Label
 Friend WithEvents Label2 As System.Windows.Forms.Label
 <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
  Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(AttributeAndFDSetDetails))
  Me.lbAttributes = New System.Windows.Forms.ListBox
  Me.lbFDSet = New System.Windows.Forms.ListBox
  Me.btnOK = New System.Windows.Forms.Button
  Me.Label1 = New System.Windows.Forms.Label
  Me.Label2 = New System.Windows.Forms.Label
  Me.SuspendLayout()
  '
  'lbAttributes
  '
  Me.lbAttributes.Location = New System.Drawing.Point(16, 32)
  Me.lbAttributes.Name = "lbAttributes"
  Me.lbAttributes.Size = New System.Drawing.Size(264, 95)
  Me.lbAttributes.TabIndex = 0
  '
  'lbFDSet
  '
  Me.lbFDSet.Location = New System.Drawing.Point(16, 160)
  Me.lbFDSet.Name = "lbFDSet"
  Me.lbFDSet.Size = New System.Drawing.Size(264, 95)
  Me.lbFDSet.TabIndex = 1
  '
  'btnOK
  '
  Me.btnOK.Location = New System.Drawing.Point(109, 264)
  Me.btnOK.Name = "btnOK"
  Me.btnOK.TabIndex = 2
  Me.btnOK.Text = "OK"
  '
  'Label1
  '
  Me.Label1.Location = New System.Drawing.Point(96, 8)
  Me.Label1.Name = "Label1"
  Me.Label1.TabIndex = 3
  Me.Label1.Text = "Attribute Set:"
  Me.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
  '
  'Label2
  '
  Me.Label2.Location = New System.Drawing.Point(96, 136)
  Me.Label2.Name = "Label2"
  Me.Label2.TabIndex = 4
  Me.Label2.Text = "FD Set:"
  Me.Label2.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
  '
  'AttributeAndFDSetDetails
  '
  Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
  Me.ClientSize = New System.Drawing.Size(292, 294)
  Me.Controls.Add(Me.Label2)
  Me.Controls.Add(Me.Label1)
  Me.Controls.Add(Me.btnOK)
  Me.Controls.Add(Me.lbFDSet)
  Me.Controls.Add(Me.lbAttributes)
  Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
  Me.Name = "AttributeAndFDSetDetails"
  Me.Text = "Attribute and FD Set Details"
  Me.ResumeLayout(False)

 End Sub

#End Region

#End Region

#Region "Button-click event handlers"

 Private Sub AttributeAndFDSetDetails_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
  ' This function runs when the form is done loading. So now we can display the Attribute Set and FD Set in the two listboxes in the form.
  For Each attributeName As String In AttributeSet
   lbAttributes.Items.Add(attributeName)    ' This adds the attribute name (a string) to the listbox called lbAttributes.
  Next
  For Each fd As FunctionalDependency In FDSet
   Dim fdString As String = ""
   ' First add the name of each attribute in the LHS of this FD object.
   For Each attributeIndex As Integer In fd.LeftHandSide
    If attributeIndex < 0 Or attributeIndex >= AttributeSet.Count Then
     fdString = fdString + "[unknown attribute " + (attributeIndex + 1) + "]"     ' note: the +1 here is because the ArrayList is a zero-based index.
    Else
     fdString = fdString + AttributeSet(attributeIndex) + " "    ' Add the name of this attribute to the left-hand-side list.
    End If
   Next
   fdString = fdString + "-> "
   ' Now add the name of each attribute in the RHS of this FD object.
   For Each attributeIndex As Integer In fd.RightHandSide
    If attributeIndex < 0 Or attributeIndex >= AttributeSet.Count Then
     fdString = fdString + "[unknown attribute " + (attributeIndex + 1) + "]"     ' note: the +1 here is because the ArrayList is a zero-based index.
    Else
     fdString = fdString + AttributeSet(attributeIndex) + " "    ' Add the name of this attribute to the left-hand-side list.
    End If
   Next
   lbFDSet.Items.Add(fdString)    ' This adds the string to the listbox called lbFDSet.
  Next
 End Sub
 Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
  Close()
 End Sub

#End Region

End Class
