' Functional Dependency Application
' Written by David J. Stein, Esq., Kevin Hardy, and Craig White. See "License.html" for terms and conditions of use.
'
' Check_2NF_Status - written by Craig White
' This module checks a functional dependency set for second normal form.

Public Class Check_2NF_Status
 Inherits System.Windows.Forms.Form

#Region "Variables and initialization code"

 Dim Attributes As ArrayList
 Dim FunctionalDependencies As ArrayList
 Private x As Integer
 Private y As Integer

#Region " Windows Form Designer generated code "

 Public Sub New(ByRef Attributes As ArrayList, ByRef FunctionalDependencies As ArrayList, ByVal x As Integer, ByVal y As Integer)
  MyBase.New()
  Me.x = x
  Me.y = y

  'This call is required by the Windows Form Designer.
  InitializeComponent()

  'Add any initialization after the InitializeComponent() call
  Me.Attributes = Attributes
  Me.FunctionalDependencies = FunctionalDependencies
 End Sub

 'Form overrides dispose to clean up the component list.
 Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
  If disposing Then
   If Not (components Is Nothing) Then
    components.Dispose()
   End If
  End If
  MyBase.Dispose(disposing)
 End Sub

 'Required by the Windows Form Designer
 Private components As System.ComponentModel.IContainer

 'NOTE: The following procedure is required by the Windows Form Designer
 'It can be modified using the Windows Form Designer.  
 'Do not modify it using the code editor.
 Friend WithEvents txt2NF As System.Windows.Forms.RichTextBox
 Friend WithEvents lbl2NF As System.Windows.Forms.Label
 Friend WithEvents btnOK As System.Windows.Forms.Button
 <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
  Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(Check_2NF_Status))
  Me.txt2NF = New System.Windows.Forms.RichTextBox
  Me.btnOK = New System.Windows.Forms.Button
  Me.lbl2NF = New System.Windows.Forms.Label
  Me.SuspendLayout()
  '
  'txt2NF
  '
  Me.txt2NF.Location = New System.Drawing.Point(8, 32)
  Me.txt2NF.Name = "txt2NF"
  Me.txt2NF.ShowSelectionMargin = True
  Me.txt2NF.Size = New System.Drawing.Size(312, 376)
  Me.txt2NF.TabIndex = 1
  Me.txt2NF.Text = ""
  '
  'btnOK
  '
  Me.btnOK.Location = New System.Drawing.Point(126, 416)
  Me.btnOK.Name = "btnOK"
  Me.btnOK.TabIndex = 0
  Me.btnOK.Text = "OK"
  '
  'lbl2NF
  '
  Me.lbl2NF.Location = New System.Drawing.Point(47, 8)
  Me.lbl2NF.Name = "lbl2NF"
  Me.lbl2NF.Size = New System.Drawing.Size(232, 21)
  Me.lbl2NF.TabIndex = 2
  Me.lbl2NF.Text = "2NF Status:"
  Me.lbl2NF.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
  '
  'Check_2NF_Status
  '
  Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
  Me.ClientSize = New System.Drawing.Size(326, 444)
  Me.Controls.Add(Me.lbl2NF)
  Me.Controls.Add(Me.btnOK)
  Me.Controls.Add(Me.txt2NF)
  Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D
  Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
  Me.Name = "Check_2NF_Status"
  Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent
  Me.Text = "Check 2NF Status"
  Me.ResumeLayout(False)

 End Sub

#End Region

 Private Sub Check_2NF_Status_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
  Me.Location = New Point(x, y)
  Dim PD As Boolean ' Partial Dependency
  Dim NPA As Integer
  Dim theKey As Integer
  txt2NF.Clear()
  PD = CheckPartialDependencyStatus()
  If (PD = False) Then
   txt2NF.Text = "This relation is 2NF."
  Else
   txt2NF.Text = "This relation is not 2NF because" & txt2NF.Text
  End If
  txt2NF.Update()
  'txt2NF.Refresh()
 End Sub

#End Region

#Region "Button-click event handlers"

 Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
  Me.Close()
 End Sub

#End Region

#Region "Core functions"

 Public Function CheckPartialDependencyStatus() As Boolean
  Dim i As Integer ' loop var
  Dim j As Integer ' loop var
  Dim v As Integer ' loop var
  Dim count As Integer ' loop var
  ' find keys
  Dim FK As FindKeys
  Dim NPA As New ArrayList ' Non-Prime Attributes
  Dim KF As New KeyFinder
  Dim KeyAttributes As New ArrayList
  Dim Keys As New ArrayList
  Dim SuperKeys As New ArrayList
  Dim subKey As New ArrayList
  Dim currentKey As New ArrayList
  Dim subKey_plus As New ArrayList
  Dim L As New LinClosure

  For i = 0 To Attributes.Count - 1
   KeyAttributes.Add(i)
  Next

  NPA = KF.FindNonPrimeAttributes(Attributes, FunctionalDependencies)
  KF.RecursiveKeyTest(Attributes, KeyAttributes, FunctionalDependencies, Keys, SuperKeys)
  For i = 0 To Keys.Count - 1
   currentKey = Keys(i)
   For j = 0 To currentKey.Count - 1
    subKey.Clear()
    For v = 0 To currentKey.Count - 1
     If v <> j Then
      subKey.Add(currentKey(v))
     End If
    Next v
    ' test sub key
    subKey_plus = L.ComputeLinClosure(Attributes, subKey, FunctionalDependencies)
    For v = 0 To subKey_plus.Count - 1
     For count = 0 To NPA.Count - 1
      'If (NPA(count) = UniversalAttributeSet(subKey_plus(v))) Then
      If (NPA(count) = subKey_plus(v)) Then
       For KeyAttribute As Integer = 0 To currentKey.Count - 1
        txt2NF.Text = txt2NF.Text & Attributes(currentKey(KeyAttribute)) & " "
       Next KeyAttribute
       txt2NF.Text = " " & Attributes(NPA(count)) & " is partially dependent on " & txt2NF.Text + "."
       Return True
      End If
     Next count
    Next v
   Next j
  Next i

  Return False

 End Function

#End Region

End Class

Public Class Check_2NF

#Region "Variables"

 ' UAS parameter = Universal Attribute Set
 ' FDS parameter = Functional Dependency Set
 Private UniversalAttributeSet As ArrayList
 Private FDSet As ArrayList

#End Region

#Region "Core functions"

 Public Function Check2NFStatus(ByVal UAS As ArrayList, ByVal FDS As ArrayList)
  Dim PD As Boolean ' Partial Dependency
  PD = CheckPartialDependencyStatus(UAS, FDS)
  If (PD = False) Then
   Return True
  Else
   Return False
  End If
 End Function

 Public Function CheckPartialDependencyStatus(ByVal UAS As ArrayList, ByVal FDS As ArrayList) As Boolean
  UniversalAttributeSet = New ArrayList
  FDSet = New ArrayList
  Dim i As Integer ' loop var
  Dim j As Integer ' loop var
  Dim v As Integer ' loop var
  Dim count As Integer ' loop var
  ' find keys
  Dim FK As FindKeys
  Dim NPA As New ArrayList ' Non-Prime Attributes
  Dim KF As New KeyFinder
  Dim KeyAttributes As New ArrayList
  Dim Keys As New ArrayList
  Dim SuperKeys As New ArrayList
  Dim subKey As New ArrayList
  Dim currentKey As New ArrayList
  Dim subKey_plus As New ArrayList
  Dim L As New LinClosure

  For i = 0 To UAS.Count - 1
   UniversalAttributeSet.Add(UAS(i))
  Next i

  For i = 0 To FDS.Count - 1
   FDSet.Add(FDS(i))
  Next i

  For i = 0 To UniversalAttributeSet.Count - 1
   KeyAttributes.Add(i)
  Next

  'FK.ShowDialog()
  NPA = KF.FindNonPrimeAttributes(UniversalAttributeSet, FDSet)
  KF.RecursiveKeyTest(UniversalAttributeSet, KeyAttributes, FDSet, Keys, SuperKeys)
  For i = 0 To Keys.Count - 1
   currentKey = Keys(i)
   For j = 0 To currentKey.Count - 1
    For v = 0 To currentKey.Count - 1
     If v <> j Then
      subKey.Add(currentKey(v))
     End If
    Next v
    ' test sub key
    subKey_plus = L.ComputeLinClosure(UniversalAttributeSet, subKey, FDSet)
    For v = 0 To subKey_plus.Count - 1
     For count = 0 To NPA.Count - 1
      'If (NPA(count) = UniversalAttributeSet(subKey_plus(v))) Then
      If (NPA(count) = subKey_plus(v)) Then
       Return True
      End If
     Next count
    Next v
   Next j
  Next i

  Return False

 End Function

#End Region

#Region "Helper functions"

 Public Sub SetUAS(ByVal UAS As ArrayList)
  ' set UniversalAttributeSet"
  UniversalAttributeSet = New ArrayList
  FDSet = New ArrayList
  Dim i As Integer ' loop var
  For i = 0 To UAS.Count
   UniversalAttributeSet.Add(UAS(i))
  Next i
 End Sub

 ' set FDSet
 Public Sub setFDS(ByVal FDS As ArrayList)
  Dim i As Integer ' loop var
  For i = 0 To FDS.Count
   FDSet.Add(FDS(i))
  Next i
 End Sub

#End Region

End Class
