' Functional Dependency Application
' Written by David J. Stein, Esq., Kevin Hardy, and Craig White. See "License.html" for terms and conditions of use.
'
' FindKeys - written by David J. Stein, Esq.
' This module finds all of the keys in an attribute set, given a functional dependency set.

Public Class FindKeys
 Inherits System.Windows.Forms.Form

#Region "Variables and initialization code"

 Dim UniversalAttributeSet As ArrayList
 Dim FDSet As ArrayList
 Private x As Integer
 Private y As Integer

 Private Sub FindKeys_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
  ' Move form
  Location = New Point(x, y)
  ' Construct total attribute set key
  Dim TotalAttributeSet As New ArrayList
  For i As Integer = 0 To UniversalAttributeSet.Count - 1
   TotalAttributeSet.Add(i)
  Next
  ' Find all keys using KeyFinder utility class
  Dim Keys As New ArrayList
  Dim SuperKeys As New ArrayList
  Dim k As New KeyFinder
  k.RecursiveKeyTest(UniversalAttributeSet, TotalAttributeSet, FDSet, Keys, SuperKeys)
  ' Display keys
  For Each Key As ArrayList In Keys
   Dim KeyString As String = ""
   For Each KeyAttribute As Integer In Key
    KeyString += UniversalAttributeSet(KeyAttribute)
   Next
   lstKeys.Items.Add(KeyString)
  Next
  ' Display superkeys
  For Each SuperKey As ArrayList In SuperKeys
   Dim SuperKeyString As String = ""
   For Each SuperKeyAttribute As Integer In SuperKey
    SuperKeyString += UniversalAttributeSet(SuperKeyAttribute)
   Next
   lstSuperKeys.Items.Add(SuperKeyString)
  Next
 End Sub

#Region " Windows Form Designer generated code "

 Public Sub New(ByVal UniversalAttributeSet As ArrayList, ByVal FDSet As ArrayList, ByVal x As Integer, ByVal y As Integer)
  MyBase.New()
  InitializeComponent()
  Me.x = x
  Me.y = y
  Me.UniversalAttributeSet = UniversalAttributeSet
  Me.FDSet = FDSet
 End Sub

 'Form overrides dispose to clean up the component list.
 Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
  If disposing Then
   If Not (components Is Nothing) Then
    components.Dispose()
   End If
  End If
  MyBase.Dispose(disposing)
 End Sub

 'Required by the Windows Form Designer
 Private components As System.ComponentModel.IContainer

 'NOTE: The following procedure is required by the Windows Form Designer
 'It can be modified using the Windows Form Designer.  
 'Do not modify it using the code editor.
 Friend WithEvents lstKeys As System.Windows.Forms.ListBox
 Friend WithEvents GroupBox1 As System.Windows.Forms.GroupBox
 Friend WithEvents GroupBox2 As System.Windows.Forms.GroupBox
 Friend WithEvents lstSuperKeys As System.Windows.Forms.ListBox
 <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
  Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(FindKeys))
  Me.lstKeys = New System.Windows.Forms.ListBox
  Me.GroupBox1 = New System.Windows.Forms.GroupBox
  Me.GroupBox2 = New System.Windows.Forms.GroupBox
  Me.lstSuperKeys = New System.Windows.Forms.ListBox
  Me.GroupBox1.SuspendLayout()
  Me.GroupBox2.SuspendLayout()
  Me.SuspendLayout()
  '
  'lstKeys
  '
  Me.lstKeys.Location = New System.Drawing.Point(16, 24)
  Me.lstKeys.Name = "lstKeys"
  Me.lstKeys.SelectionMode = System.Windows.Forms.SelectionMode.None
  Me.lstKeys.Size = New System.Drawing.Size(152, 160)
  Me.lstKeys.Sorted = True
  Me.lstKeys.TabIndex = 0
  '
  'GroupBox1
  '
  Me.GroupBox1.Controls.Add(Me.lstKeys)
  Me.GroupBox1.Location = New System.Drawing.Point(16, 16)
  Me.GroupBox1.Name = "GroupBox1"
  Me.GroupBox1.Size = New System.Drawing.Size(184, 200)
  Me.GroupBox1.TabIndex = 1
  Me.GroupBox1.TabStop = False
  Me.GroupBox1.Text = "Keys"
  '
  'GroupBox2
  '
  Me.GroupBox2.Controls.Add(Me.lstSuperKeys)
  Me.GroupBox2.Location = New System.Drawing.Point(16, 232)
  Me.GroupBox2.Name = "GroupBox2"
  Me.GroupBox2.Size = New System.Drawing.Size(184, 200)
  Me.GroupBox2.TabIndex = 2
  Me.GroupBox2.TabStop = False
  Me.GroupBox2.Text = "Superkeys"
  '
  'lstSuperKeys
  '
  Me.lstSuperKeys.Location = New System.Drawing.Point(16, 24)
  Me.lstSuperKeys.Name = "lstSuperKeys"
  Me.lstSuperKeys.SelectionMode = System.Windows.Forms.SelectionMode.None
  Me.lstSuperKeys.Size = New System.Drawing.Size(152, 160)
  Me.lstSuperKeys.Sorted = True
  Me.lstSuperKeys.TabIndex = 0
  '
  'FindKeys
  '
  Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
  Me.ClientSize = New System.Drawing.Size(216, 448)
  Me.Controls.Add(Me.GroupBox1)
  Me.Controls.Add(Me.GroupBox2)
  Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle
  Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
  Me.MaximizeBox = False
  Me.MinimizeBox = False
  Me.Name = "FindKeys"
  Me.ShowInTaskbar = False
  Me.Text = "Find Keys"
  Me.GroupBox1.ResumeLayout(False)
  Me.GroupBox2.ResumeLayout(False)
  Me.ResumeLayout(False)

 End Sub

#End Region

#End Region

End Class

Public Class KeyFinder

#Region "Core functions"

 Public Function RecursiveKeyTest(ByVal UniversalAttributeSet As ArrayList, ByVal KeyAttributeSet As ArrayList, ByVal FDSet As ArrayList, ByRef Keys As ArrayList, ByRef SuperKeys As ArrayList) As Boolean
  ' Construct selected array list to pass to LinClosure function
  Dim LinClosureObject As New LinClosure
  Dim RHS As ArrayList = LinClosureObject.ComputeLinClosure(UniversalAttributeSet, KeyAttributeSet, FDSet)
  ' Find Results
  If RHS.Count < UniversalAttributeSet.Count Then
   Return False
  Else
   ' This is a key - test to see if it's a superkey.
   Dim SuperKey As Boolean = False
   For TestAttribute As Integer = 0 To KeyAttributeSet.Count - 1
    Dim SubKeyAttributeSet As New ArrayList
    For i As Integer = 0 To KeyAttributeSet.Count - 1
     If i <> TestAttribute Then
      SubKeyAttributeSet.Add(KeyAttributeSet(i))
     End If
    Next
    If Me.RecursiveKeyTest(UniversalAttributeSet, SubKeyAttributeSet, FDSet, Keys, SuperKeys) = True Then
     SuperKey = True
    End If
   Next
   Dim Found As Boolean = False
   If SuperKey = True Then
    For Each KnownSuperKey As ArrayList In SuperKeys
     If KnownSuperKey.Count = KeyAttributeSet.Count Then
      Dim Same As Boolean = True
      For i As Integer = 0 To KnownSuperKey.Count - 1
       If KnownSuperKey(i) <> KeyAttributeSet(i) Then
        Same = False
       End If
      Next
      If Same = True Then
       Found = True
      End If
     End If
    Next
    If Found = False Then
     SuperKeys.Add(KeyAttributeSet)
    End If
   Else
    For Each KnownKey As ArrayList In Keys
     If KnownKey.Count = KeyAttributeSet.Count Then
      Dim Same As Boolean = True
      For i As Integer = 0 To KnownKey.Count - 1
       If KnownKey(i) <> KeyAttributeSet(i) Then
        Same = False
       End If
      Next
      If Same = True Then
       Found = True
      End If
     End If
    Next
    If Found = False Then
     Keys.Add(KeyAttributeSet)
    End If
   End If
  End If
  Return True
 End Function

 Public Function FindNonPrimeAttributes(ByRef Attributes As ArrayList, ByRef FunctionalDependencies As ArrayList) As ArrayList
  Dim NonPrimeAttributes As New ArrayList
  Dim TotalAttributeSet As New ArrayList
  Dim Keys As New ArrayList
  Dim SuperKeys As New ArrayList
  For i As Integer = 0 To Attributes.Count - 1
   TotalAttributeSet.Add(i)
  Next
  RecursiveKeyTest(Attributes, TotalAttributeSet, FunctionalDependencies, Keys, SuperKeys)
  For Attribute As Integer = 0 To Attributes.Count - 1
   Dim Found As Boolean = False
   For Each Key As ArrayList In Keys
    For Each PrimeAttribute As Integer In Key
     If Attribute = PrimeAttribute Then
      Found = True
     End If
    Next
   Next
   If Found = False Then  ' This is a nonprime attribute - test it
    NonPrimeAttributes.Add(Attribute)
   End If
  Next
  Return NonPrimeAttributes
 End Function

#End Region

End Class
