' Functional Dependency Application
' Written by David J. Stein, Esq., Kevin Hardy, and Craig White. See "License.html" for terms and conditions of use.
'
' SaveFDSet - written by David J. Stein, Esq.
' This module saves a functional dependency set to disk and updates the catalog.

Public Class SaveFDSet
 Inherits System.Windows.Forms.Form

#Region "Variables and initialization code"

 Friend SelectedFilename As String = ""
 Friend SelectedFullFilename As String = ""
 Friend BasePath As String = ""

#Region " Windows Form Designer generated code "

 Public Sub New()
  MyBase.New()

  'This call is required by the Windows Form Designer.
  InitializeComponent()

  'Add any initialization after the InitializeComponent() call

 End Sub

 'Form overrides dispose to clean up the component list.
 Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
  If disposing Then
   If Not (components Is Nothing) Then
    components.Dispose()
   End If
  End If
  MyBase.Dispose(disposing)
 End Sub

 'Required by the Windows Form Designer
 Private components As System.ComponentModel.IContainer

 'NOTE: The following procedure is required by the Windows Form Designer
 'It can be modified using the Windows Form Designer.  
 'Do not modify it using the code editor.
 Friend WithEvents Label1 As System.Windows.Forms.Label
 Friend WithEvents txtFilename As System.Windows.Forms.TextBox
 Friend WithEvents btnSave As System.Windows.Forms.Button
 Friend WithEvents btnCancel As System.Windows.Forms.Button
 <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
  Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(SaveFDSet))
  Me.Label1 = New System.Windows.Forms.Label
  Me.txtFilename = New System.Windows.Forms.TextBox
  Me.btnSave = New System.Windows.Forms.Button
  Me.btnCancel = New System.Windows.Forms.Button
  Me.SuspendLayout()
  '
  'Label1
  '
  Me.Label1.Location = New System.Drawing.Point(16, 16)
  Me.Label1.Name = "Label1"
  Me.Label1.Size = New System.Drawing.Size(88, 23)
  Me.Label1.TabIndex = 0
  Me.Label1.Text = "FD Set Name:"
  Me.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
  '
  'txtFilename
  '
  Me.txtFilename.Location = New System.Drawing.Point(104, 16)
  Me.txtFilename.Name = "txtFilename"
  Me.txtFilename.Size = New System.Drawing.Size(176, 20)
  Me.txtFilename.TabIndex = 0
  Me.txtFilename.Text = ""
  '
  'btnSave
  '
  Me.btnSave.Location = New System.Drawing.Point(48, 56)
  Me.btnSave.Name = "btnSave"
  Me.btnSave.TabIndex = 1
  Me.btnSave.Text = "Save"
  '
  'btnCancel
  '
  Me.btnCancel.Location = New System.Drawing.Point(168, 56)
  Me.btnCancel.Name = "btnCancel"
  Me.btnCancel.TabIndex = 2
  Me.btnCancel.Text = "Cancel"
  '
  'SaveFDSet
  '
  Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
  Me.ClientSize = New System.Drawing.Size(292, 94)
  Me.Controls.Add(Me.btnCancel)
  Me.Controls.Add(Me.btnSave)
  Me.Controls.Add(Me.txtFilename)
  Me.Controls.Add(Me.Label1)
  Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D
  Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
  Me.Name = "SaveFDSet"
  Me.ShowInTaskbar = False
  Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent
  Me.Text = "Save Functional Depenency Set"
  Me.ResumeLayout(False)

 End Sub

#End Region

#End Region

#Region "Button-click event handlers"

 Private Sub btnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave.Click
  SelectedFilename = txtFilename.Text
  BasePath = System.Reflection.Assembly.GetExecutingAssembly().Location
  BasePath = BasePath.Substring(0, BasePath.Length - 37)
  SelectedFullFilename = BasePath + "$F_" + SelectedFilename
  DialogResult = DialogResult.OK
  Close()
 End Sub

 Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
  DialogResult = DialogResult.Cancel
  Close()
 End Sub

 Private Sub txtFilename_KeyDown(ByVal sender As System.Object, ByVal e As KeyEventArgs) Handles txtFilename.KeyDown
  If e.KeyCode = Keys.Enter Then
   SelectedFilename = txtFilename.Text
   BasePath = System.Reflection.Assembly.GetExecutingAssembly().Location
   BasePath = BasePath.Substring(0, BasePath.Length - 37)
   SelectedFullFilename = BasePath + "$F_" + SelectedFilename
   DialogResult = DialogResult.OK
   Close()
  End If
 End Sub

#End Region

End Class
